import 'package:dyte_core/dyte_core.dart';
import 'package:dyte_core_example/models/states/room_event_states.dart';
import 'package:flutter_riverpod/flutter_riverpod.dart';

class RoomStateNotifier extends StateNotifier<RoomEventStates>
    with DyteMeetingRoomEventsListener {
  RoomStateNotifier() : super(const RoomEventStates.initial());

  @override
  void onChatUpdates(
      {required bool newMessage,
      DyteChatMessage? message,
      required List<DyteChatMessage> messages}) {
    state = RoomEventStates.onChatUpdates(
        newMessage: newMessage, messages: messages);
  }

  @override
  void onMeetingInitCompleted() {
    state = const RoomEventStates.onMeetingInitCompleted();
  }

  @override
  void onMeetingInitFailed(Exception exception) {
    state = RoomEventStates.onMeetingInitFailed(exception);
  }

  @override
  void onMeetingInitStarted() {
    state = const RoomEventStates.onMeetingInitStarted();
  }

  @override
  void onMeetingRecordingEnded() {
    state = const RoomEventStates.onMeetingRecordingEnded();
  }

  @override
  void onMeetingRecordingStarted() {
    state = const RoomEventStates.onMeetingRecordingStarted();
  }

  @override
  void onMeetingRecordingStopError() {
    state = const RoomEventStates.onMeetingRecordingStopError();
  }

  @override
  void onMeetingRoomDisconnected() {
    state = const RoomEventStates.onMeetingRoomDisconnected();
  }

  @override
  void onMeetingRoomJoinFailed(Exception exception) {
    state = RoomEventStates.onMeetingRoomJoinFailed(exception);
  }

  @override
  void onMeetingRoomJoinStarted() {
    state = const RoomEventStates.onMeetingRoomJoinStarted();
  }

  @override
  void onMeetingRoomJoined(String meetingStartedAt) {
    state = RoomEventStates.onMeetingRoomJoined(meetingStartedAt);
  }

  @override
  void onMeetingRoomLeft() {
    state = const RoomEventStates.onMeetingRoomLeft();
  }

  @override
  void onPollUpdates({
    required bool newPoll,
    required List<DytePollMessage> pollMessages,
    DytePollMessage? updatedPollMessage,
  }) {
    state = RoomEventStates.onPollUpdates(
      newPoll: newPoll,
      pollMessages: pollMessages,
      dytePollMessage: updatedPollMessage,
    );
  }
}
