import 'package:dyte_core_platform_interface/dyte_core_platform_interface.dart';

DyteClientPlatform get _platform => DyteClientPlatform.instance;

class DyteMobileClient {
  void init(DyteMeetingInfo meetingInfo) => _platform.init(meetingInfo);

  void joinRoom() => _platform.joinRoom();

  void leaveRoom() => _platform.leaveRoom();

  DyteRoomParticipants get participants => _platform.particpants;

  Stream<DyteRoomParticipants> get participantsStream =>
      _platform.particpantsStream;

  void closeParticipantsStream() => _platform.closeParticipantsStream();

  void addMeetingRoomEventsListener(
          DyteMeetingRoomEventsListener meetingRoomEventsListener) =>
      _platform.addMeetingRoomEventsListener(meetingRoomEventsListener);

  void removeMeetingRoomEventsListener(
          DyteMeetingRoomEventsListener meetingRoomEventsListener) =>
      _platform.removeMeetingRoomEventsListener(meetingRoomEventsListener);

  void addParticipantEventsListener(
          DyteParticipantEventsListener participantEventsListener) =>
      _platform.addParticipantEventListener(participantEventsListener);

  DyteLocalUser get localUser => _platform.localUser;

  void addSelfEventsListener(DyteSelfEventsListener dyteSelfListener) =>
      _platform.addDyteSelfParticipantListener(dyteSelfListener);

  DyteChat get chat => _platform.chat;
}
